/* gread.c     read in data from a GIF format file    -jpb 6/25/95    */

/* gread.c   uses routines from the gd 1.1.1 library:
   ----------------------------------------------------------------------
   gd 1.1.1 is copyright 1994, Quest Protein Database Center, Cold Spring
   Harbor Labs. Permission granted to copy and distribute this work
   provided that this notice remains intact.

	Tom Boutell, boutell@netcom.com
	http://sunsite.unc.edu/boutell/index.html
	116 14th Ave E Apt 2
	Seattle, WA 98102
*/

#include <stdio.h>                      /* fopen() sprintf() etc. */
#include <stdlib.h>                     /* strtod() */
#include <string.h>                     /* strcpy() */

#include <gd.h>
#include <gdfontl.h>
#include <gdfonts.h>
#include "hl.h"

/* ---------------------------------------------------------------------- */
/* gread1() --   read in data to hf array (xsize x ysize) from a GIF file  */
/*              <fname>, interpreting the index as the value, ignoring    */
/*              the color pallette entirely.                              */
/* ---------------------------------------------------------------------- */

int gread1(hfield *hfp, char *fname)
{
    hfield hf;
    int xsize, ysize;         
    FILE *pin;
    gdImagePtr im;
    int x,y;

    pin = fopen(fname, "rb");
    if (pin == NULL) fprintf(stderr,"Could not open %s.\n",fname);
    im = gdImageCreateFromGif(pin);
    fclose(pin);

    xsize = gdImageSX(im);
    ysize = gdImageSY(im);

   if (h_newr(&hf,xsize,ysize,fname)) return(1);

    for (x=0;x<xsize;x++) {    /* transfer pixel array to hf data  */
      for (y=0;y<ysize;y++) {
	  El(hf.a,x,y) = (float) (im->pixels[x][y]) / 255.0;
      }
    }
    gdImageDestroy(im);         /* free up memory */

    *hfp = hf;
    return(0);
} /* gread1() */
