
/* x_test.c  --  test out some uninformed ideas about how X works 
 *                John Beale 2/11/96
 */

/*
   
     Pixmap XCreatePixmapFromBitmapData(display, d, data, width,
          height, fg, bg, depth)

    Display *display; Drawable d; char *data; unsigned int width, height;
    unsigned long fg, bg; unsigned int depth;
								      

     display   Specifies the connection to the X server.
     d         Specifies the drawable that indicates the screen.

     data      Specifies the location of the bitmap data.

     width
     height    Specify the width and height.

     fg
     bg        Specify the foreground and background pixel values

     depth     Specifies the depth of the pixmap.

     The XCreatePixmapFromBitmapData function creates a pixmap of the given
     depth and then does a bitmap-format XPutImage of the data into it.
     The depth must be supported by the screen of the specified drawable,
     or a BadMatch error results.

 -------------------------------------------------------------------

     XPutImage(display, d, gc, image, src x, src y, dest x,
     dest y, width, height)
             Display *display;
             Drawable d;
             GC gc;
             XImage *image;                <-- the image to draw onscreen
             int src x, src y;
             int dest x, dest y;
             unsigned int width, height;


     The XPutImage function combines an image in memory with a
     rectangle of the specified drawable.  If XYBitmap format is
     used, the depth of the image must be one, or a BadMatch
     error results.  The foreground pixel in the GC defines the
     source for the one bits in the image, and the background
     pixel defines the source for the zero bits.  For XYPixmap
     and ZPixmap, the depth of the image must match the depth of
     the drawable, or a BadMatch error results.  The section of
     the image defined by the src x, src y, width, and height
     arguments is drawn on the specified part of the drawable.

 ---------------------------------------------------------------------- 
  the (char *)data taken by XCreatePixmap...() is the raw bytes in 1,2,4 bytes-
   per-pixel format 
   

   Sample code fragment: ----------------------------------------------

XImage        *theImage;     /* starts off as just a pointer to XImage struct */
Pixmap        pix_map = 0;   /* X11 Pixmap structure */
UBYTE         *tmp_pic;      /* pointer to unsigned char  (raw bytes) */

      pix_map = XCreatePixmapFromBitmapData(theDisp,mainW,(char *)tmp_pic,
                         X11_Get_Bitmap_Width(xsize),ysize,0x01,0x00,1);
      XSetClipMask(theDisp,theGC,pix_map);
      XSetClipOrigin(theDisp,theGC,xp,yp);


      theImage->width = xsize;     /* construct the XImage for display */
      theImage->height = ysize;
      theImage->bytes_per_line = line_size;
      theImage->data = (char *)tmp_pic;
                
      XPutImage(theDisp,mainW,theGC,theImage,0,0,xp,yp,xsize,ysize);


 ----------------------------------------------------------------------










